﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Numerics;
using System.Threading;

namespace Factorize
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Synchronous execution");
            for (Int32 i = 0; i < 8; ++i)
                FactorizeSlow(10 + i * 5);

            Console.WriteLine("Asynchronous execution");
            List<Thread> threads = new List<Thread>(8);
            for (Int32 i = 0; i < 8; ++i)
            {
                Thread thread = new Thread(new ParameterizedThreadStart(FactorizeSlow));
                thread.Start(10 + i * 5);
                threads.Add(thread);
            }

            threads.ForEach(t => t.Join());
            Console.WriteLine("Using threadpools");
            for (Int32 i = 0; i < 8; ++i)
                ThreadPool.QueueUserWorkItem(FactorizeSlow, 10 + i * 5);
            
            Console.ReadKey();
        }

        static void FactorizeSlow(Object nObject)
        {
            Int32 n = 0;
            try
            {
                n = Convert.ToInt32(nObject);
            }
            catch (Exception) { }

            BigInteger result = 1;
            for (Int32 i = 2; i < n; ++i)
            {
                result *= i;
                Thread.Sleep(100);
            }

            Console.WriteLine(n + "! = ");
            Console.WriteLine(result);
            Console.WriteLine();
        }
    }
}
