﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Fibonacci
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Start");
            RealMain();
            Console.WriteLine("End");
            Console.ReadKey();
        }

        static async void RealMain()
        {
            Console.WriteLine("Create asynchron tasks");
            Task<Int32>[] tasks = new Task<Int32>[5];
            tasks[0] = FibonacciAsync(20);
            tasks[1] = FibonacciAsync(25);
            tasks[2] = FibonacciAsync(30);
            tasks[3] = FibonacciAsync(35);
            tasks[4] = FibonacciAsync(40);

            Console.WriteLine("Run synchronized calculations");
            Console.WriteLine("[Sync] Fibonacci(20) = " + FibonacciSlow(20));
            Console.WriteLine("[Sync] Fibonacci(25) = " + FibonacciSlow(25));
            Console.WriteLine("[Sync] Fibonacci(30) = " + FibonacciSlow(30));
            Console.WriteLine("[Sync] Fibonacci(35) = " + FibonacciSlow(35));
            Console.WriteLine("[Sync] Fibonacci(40) = " + FibonacciSlow(40));

            Console.WriteLine("Wait for asynchronized calculation results");
            Int32[] results = new Int32[5];
            results[0] = await tasks[0];
            results[1] = await tasks[1];
            results[2] = await tasks[2];
            results[3] = await tasks[3];
            results[4] = await tasks[4];

            Console.WriteLine("[Aync] Fibonacci(20) = " + results[0]);
            Console.WriteLine("[Aync] Fibonacci(25) = " + results[1]);
            Console.WriteLine("[Aync] Fibonacci(30) = " + results[2]);
            Console.WriteLine("[Aync] Fibonacci(35) = " + results[3]);
            Console.WriteLine("[Aync] Fibonacci(40) = " + results[4]);
            
        }
        
        static Int32 FibonacciSlow(Int32 n)
        {
            if (n < 2)
                return 1;
            else
                return FibonacciSlow(n - 1) + FibonacciSlow(n - 2);
        }

        static Task<Int32> FibonacciAsync(Int32 n)
        {
            Task<Int32> task = Task.Run(() => FibonacciSlow(n));
            return task;
        }
    }
}
